package config_manager;

use strict;

use Gtk2::Ex::Dialogs;
use Glib qw( TRUE FALSE );

use Data::Dumper;

sub new {
    
    my ( $class, $globals ) = @_;
    
    my $self;
    $self->{globals} = $globals;
    bless $self, $class;
    
    $self->{globals}->{local_db}->do(
        "create table if not exists simple_config (\n"
      . "    ID integer primary key autoincrement\n"
      . "  , key    text\n"
      . "  , value  text\n"
      . ")"
    );
    
    $self->{exists_simple_config} = $self->{globals}->{local_db}->prepare(
        "select ID, value from simple_config where key = ?"
    );
    
    $self->{update_simple_config} = $self->{globals}->{local_db}->prepare(
        "update simple_config set value = ? where ID = ?"
    );
    
    $self->{insert_simple_config} = $self->{globals}->{local_db}->prepare(
        "insert into simple_config ( key, value ) values ( ?, ? )"
    );
    
    return $self;
    
}

sub simpleSet {
    
    my ( $self, $key, $value ) = @_;
    
    $self->{exists_simple_config}->execute( $key );
    
    my $exists = $self->{exists_simple_config}->fetchrow_hashref;
    
    if ( $exists ) {
        
        $self->{update_simple_config}->execute( $value, $exists->{ID} );
        
    } else {
        
        $self->{insert_simple_config}->execute( $key, $value );
        
    }
    
}

sub simpleGet {
    
    my ( $self, $key ) = @_;
    
    $self->{exists_simple_config}->execute( $key );
    
    my $exists = $self->{exists_simple_config}->fetchrow_hashref;
    
    if ( $exists ) {
        
        return $exists->{value};
        
    } else {
        
        return undef;
        
    }
    
}

1;
