package axis::dialog;

use strict;
use POSIX;


use Glib qw ( TRUE FALSE );

sub new {
    
    my $options = shift;
    
    # $options:
    #  - type               - string        [ ]
    #  - title              - string        ( title of dialog )
    #  - parent_window      - gtkwindow     ( parent of dialog ... goes insensitive
    #  - prompt             - string        ( prompt to display to user )
    #  - inputbox           - boolean       ( create an inputbox for input )
    #  - textview           - boolean       ( create a textview for verbose input )
    #  - default            - string        ( a default value )
    
    my $dialog = Gtk3::MessageDialog->new(
        $options->{parent_window},
        [ qw/modal destroy-with-parent/ ],
        $options->{type},
        'GTK_BUTTONS_OK'
    );
    
    $dialog->set_markup( $options->{text} );
    
#    $dialog->set_gravity( 'center' );
#    $dialog->set_position( 'center-always' );
#    
#    my $content_area = $dialog->get_content_area;
#    $content_area->set_spacing( 5 );
#
#    my $table           = Gtk3::Table->new( 1, 1, TRUE );
#    my $label           = Gtk3::Label->new( '' );
#    $label->set_line_wrap( 1 );
#    $label->set_markup( $options->{prompt} );
#
#    $content_area->pack_start( $label, 0, 0, 5 );
#
#    my ( $entry, $scrolled_window, $textview );
#
#    if ( $options->{textview} ) {
#
#        $scrolled_window = Gtk3::ScrolledWindow->new;
#        $textview = Gtk3::TextView->new;
#        $textview->set_wrap_mode( 'word' );
#        $scrolled_window->add_with_viewport( $textview );
#        $content_area->pack_start( $scrolled_window, 1, 1, 5 );
#        $dialog->set_default_size( 640, 480 );
#
#        if ( $options->{default} ) {
#            $textview->get_buffer->set_text( $options->{default} );
#        }
#
#    } elsif ( $options->{inputbox} ) {
#        
#        $entry           = Gtk3::Entry->new;
#        $content_area->pack_start( $entry, 0, 0, 5 );
#
#        if ( $options->{default} ) {
#            $entry->set_text( $options->{default} );
#        }
#
#    }
    
    $dialog->show_all;

    my $response = $dialog->run;
    
    $dialog->destroy;
    
    return $response;
    
}

1;
