package powercom::viewer;

use strict;
use warnings;

sub new {
    
    my ( $class, $globals ) = @_;
    
    my $self;
    $self->{globals} = $globals;
    bless $self, $class;
    
    $self->{form} = Gtk3::Builder->new;
    
    $self->{form}->add_objects_from_file( "$self->{globals}->{builder_dir}/viewer.ui", "viewer" );
    
    $self->{form}->connect_signals( undef, $self );
    
    # Build Projects datasheet
    $self->{readings} = Gtk3::Ex::DBI::Datasheet->new(
        {
            dbh             => $self->{globals}->{db},
            sql             => {
#                                    select          => "id, reading_datetime, panel_1_voltage, accumulated_energy",
                                    select          => "*"
                                  , from            => "readings"
                                  , order_by        => "id"
                               },
            treeview        => $self->{form}->get_object( "readings_datasheet" ),
        }
    );
    
    $self->{form}->get_object( "viewer" )->show;
    
    return $self;
    
}

1;
